int digitalIn[] = {2, 3, 4, 5};
int digitalOut[] = {6, 7, 8, 9, 10, 11, 12, 13};
int analogIn[] = {A0, A1, A2, A3};
char zeichenIn[10];
char zeichenOut[9];
int count = 0;
int kanal = 0;
int i = 0;

void empfangen()
{
  for (i = 0; i < 8; i++)
  {
    if (zeichenIn[i] == 'H')
      digitalWrite(digitalOut[i], HIGH);
    else
      digitalWrite(digitalOut[i], LOW);
  }
  switch (zeichenIn[8])
  {
    case '1':
      kanal = 1;
      break;
    case '2':
      kanal = 2;
      break;
    case '3':
      kanal = 3;
      break;
    default:
      kanal = 0;
      break;
  }
}

void senden()
{
  int t, h, z, e, temp;

  for (i = 0; i < 4; i++)
    analogIn[i] = analogRead(i);
  temp = analogIn[kanal];
  t = temp / 1000;
  h = (temp - t * 1000) / 100;
  z = (temp - t * 1000 - h * 100) / 10;
  e = temp - t * 1000 - h * 100 - z * 10;
  for (i = 0; i < 4; i++)
  {
    if (digitalRead(digitalIn[i]) == 1)
      zeichenOut[i] = 'H';
    else
      zeichenOut[i] = 'L';
  }
  zeichenOut[4] = char(t) + 48;
  zeichenOut[5] = char(h) + 48;
  zeichenOut[6] = char(z) + 48;
  zeichenOut[7] = char(e) + 48;
  Serial.write(zeichenOut);
}

void setup()
{
  Serial.begin(9600);
  for (i = 0; i < 8; i++)
    pinMode(digitalOut[i], OUTPUT);
  for (i = 0; i < 4; i++)
    pinMode(digitalIn[i], INPUT);
}

void loop()
{
  count = 0;
  while (Serial.available() > 0)
  {
    zeichenIn[count] = Serial.read();
    count++;
  }
  empfangen();
  delay(5);
  senden();
}
