const int PAUSE = 500;
int digitalIn[] = {2, 3, 4, 5};
int digitalOut[] = {6, 7, 8, 9, 10, 11, 12, 13};
int analogIn[] = {A0, A1, A2, A3};
int count;
int kanal;
int i;

void setup()
{
  Serial.begin(9600);
  for (i = 0; i < 8; i++)
    pinMode(digitalOut[i], OUTPUT);
  for (i = 0; i < 4; i++)
    pinMode(digitalIn[i], INPUT_PULLUP);
}

void testDigitalOut()
{
  for (i = 0; i < 8; i++)
  {
    digitalWrite(digitalOut[i], HIGH);
    delay(PAUSE);
    digitalWrite(digitalOut[i], LOW);
    delay(PAUSE);
  }
}

void testDigitalIn()
{
  for (i = 0; i < 4; i++)
  {
    Serial.print("Digigal In ");
    Serial.print(i);
    Serial.print(": ");
    Serial.println(digitalRead(digitalIn[i]));
    delay(PAUSE);
  }
}

void testAnalogIn()
{
  digitalWrite(digitalOut[0], HIGH);
  for (int i = 0; i < 4; i++)
  {
    Serial.print("Analog In ");
    Serial.print(i);
    Serial.print(": ");
    Serial.println(analogRead(analogIn[i]));
    delay(PAUSE);
  }
  digitalWrite(digitalOut[0], LOW);
  delay(PAUSE);
}

void loop()
{
  testDigitalOut();
  testDigitalIn();
  testAnalogIn();
}
